<template>
  <div>
    <div>
      <h3>Select a plan and save</h3>
      <span v-for="option in frequencyOptions" :key="option">
        <input
            type="radio"
            :id="option"
            :value="option"
            v-model="selectedFrequency"
            @change="updateTextArea"
        />
        <label :for="option">{{ option }}</label>
      </span>
    </div>

    <div class="centered-container">
      <div class="dropdown-container">
        <label for="bedroomDropdown">How many bedrooms do you need cleaned?</label>
        <select id="bedroomDropdown" v-model="selectedBedrooms" @change="updateTextArea">
          <option v-for="option in bedroomOptions" :key="option" :value="option">{{ option }}</option>
        </select>
      </div>
    </div>

    <div class="centered-container">
      <div class="dropdown-container">
        <label for="bathroomDropdown">How many bathrooms do you need cleaned?</label>
        <select id="bathroomDropdown" v-model="selectedBathrooms" @change="updateTextArea">
          <option v-for="option in bathroomOptions" :key="option" :value="option">{{ option }}</option>
        </select>
      </div>
    </div>

    <div class="centered-container">
      <div class="dropdown-container">
        <label for="homeDropdown">What is the size of your home?</label>
        <select id="homeDropdown" v-model="selectedHome" @change="updateTextArea">
          <option v-for="option in homeOptions" :key="option" :value="option">{{ option }}</option>
        </select>
      </div>
    </div>

    <div>
      <h3>Anything else we should know?</h3>
      <textarea v-model="additionalInfo" @input="highlightText"></textarea>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      frequencyOptions: ["Once", "Monthly", "Biweekly", "Weekly"],
      selectedFrequency: "",
      bedroomOptions: ["1 bed", "2 beds", "3 beds", "4 beds", "5 beds", "6 beds", "7 beds", "8 beds", "9 beds", "10 beds"],
      bathroomOptions: ["1 bath", "2 baths", "3 baths", "4 baths", "5 baths", "6 baths", "7 baths", "8 baths", "9 baths", "10 baths"],
      homeOptions: ["Less than 1500 sqft", "1500 - 3000 sqft", "3000 - 5000 sqft", "5000+ sq ft."],
      selectedBedrooms: null,
      selectedBathrooms: null,
      selectedHome: null,
      additionalInfo: ""
    };
  },
  methods: {
    updateTextArea() {
      let description = "";

      // Frequency
      switch (this.selectedFrequency) {
        case "Once":
          description += "This is a one-time event. ";
          break;
        case "Monthly":
          description += "This event occurs once a month. ";
          break;
        case "Biweekly":
          description += "This event occurs every two weeks. ";
          break;
        case "Weekly":
          description += "This event occurs every week. ";
          break;
      }

      // Number of Bedrooms
      if (this.selectedBedrooms !== null) {
        description += "You need cleaning for " + this.selectedBedrooms + ". ";
      }

      // Number of Bathrooms
      if (this.selectedBathrooms !== null) {
        description += "You need cleaning for " + this.selectedBathrooms + ". ";
      }

      // Home Dimensions
      if (this.selectedHome !== null) {
        description += "Your home size is " + this.selectedHome + ". ";
      }

      this.additionalInfo = description;
    },
    highlightText() {
      this.additionalInfo = this.additionalInfo.replace(
          /(Once|Monthly|Biweekly|Weekly)/g,
          '<span style="text-decoration: underline; color: yellow;">$1</span>'
      );
    }
  }
};
</script>

<style>
.centered-container {
  display: flex;
  justify-content: center;
  margin-bottom: 20px;
}

.dropdown-container {
  display: flex;
  align-items: center;
}

.dropdown-container label {
  margin-right: 10px;
}
</style>
